#include "testlib.h"
#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);

    if (argc != 7) {
        cerr << "Usage: n, minS, maxS, minM, maxM, seed" << endl;

        return 1;
    }

    int n = atoi(argv[1]);
    int mins = atoi(argv[2]);
    int maxs = atoi(argv[3]);
    int minm = atoi(argv[4]);
    int maxm = atoi(argv[5]);

    cout << n << endl;
    for (int i = 0; i < n; i++)
        cout << rnd.next(mins, maxs);
    cout << endl;
    for (int i = 0; i < n; i++)
        cout << rnd.next(minm, maxm);
    cout << endl;

    return 0;
}
