#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <string>
#include <string.h>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <assert.h>
#include <algorithm>
#include <iomanip>
#include <time.h>
#include <math.h>
#include <bitset>

#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

const int INF = 1000 * 1000 * 1000 + 21;
const ll LLINF = (1ll << 60) + 5;
const int MOD = 1000 * 1000 * 1000 + 7;

const int MAX_N = 500 * 1000 + 5;
const int MAX_LEN = 500 * 1000 + 5;

int n;
string arr[MAX_N];
string new_arr[MAX_N];
char buff[MAX_LEN];
bool is_del[MAX_N];
int can_best = INF;

int gen(int ptr, int ans, int best)
{
    if (ans > can_best)
    {
        return INF;
    }
	if (ptr == n)
	{
		bool good = true;
//		for (int i = 0; i < n - 1; ++i)
//		{
//			good &= (new_arr[i] <= new_arr[i + 1]);
//		}

		if (good)
		{
			if (ans == best)
			{
				for (int i = 0; i < n; ++i)
				{
					printf("%s%s\n", new_arr[i].c_str(), (is_del[i] ? "" : ""));
				}
				exit(0);
			}
			else
			{
			    can_best = min(can_best, ans);
				return ans;
			}
		}
		else
		{
			return INF;
		}
	}
	else
	{
		new_arr[ptr] = arr[ptr];
		is_del[ptr] = true;
		int find = INF;
		for (int i = (int)arr[ptr].size() - 1; i > -1; --i)
		{
			is_del[ptr] = (i != (int)arr[ptr].size() - 1);
			if (ptr == 0 || new_arr[ptr - 1] <= new_arr[ptr])
            {
                find = min(find, gen(ptr + 1, ans + (int)arr[ptr].size() - 1 - i, best));
            }
            new_arr[ptr].pop_back();
		}

		return find;
	}
}

int main()
{
#ifdef CH_EGOR
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	//freopen("", "r", stdin);
	//freopen("", "w", stdout);
#endif

	scanf("%d", &n);

	for (int i = 0; i < n; ++i)
	{
		scanf("%s", buff);
		arr[i] = buff;
	}

	memset(is_del, 0, sizeof(is_del));

	gen(0, 0, gen(0, 0, 0));

	return 0;
}
