#include <bits/stdc++.h>
#include "testlib.h"
#define forn(i, n) for(int i = 0; i < (int)(n); i++)
#define REP(i,n) for(int (i)=0;(i)<(int)(n);(i)++)
typedef long long ll;
typedef long double ld;
using namespace std;

int readAns(int n, int m, InStream& in, vector<vector<int> >& up, vector<pair<int, int> >& q, vector<int>& mx) {
    for(int i = 0; i < (int)q.size(); i++) {
        int l = q[i].first;
        int r = q[i].second;
        int ans = in.readInt();
        if(ans == -1) {
            if(r - up[r][mx[r]] < l)
                return i + 1;
        }
        else {
            if(!(1 <= ans && ans <= m) || r - up[r][ans] >= l)
                return i + 1;
        }
    }
    return -1;
}

int main(int argc, char * argv[]) {
    //ios_base::sync_with_stdio(false);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int m = inf.readInt();
    vector<vector<int> > v(n + 1), up(n + 1);
    vector<int> mx(n + 1, 0);
    vector<pair<int, int> > q;
    for(int i = 1; i <= n; i++) {
        v[i].resize(m + 1);
        up[i].assign(m + 1, 0);
        int pos = 0;
        for(int j = 1; j <= m; j++) {
            v[i][j] = inf.readInt();
            if (i > 1 && v[i][j] >= v[i - 1][j])
                up[i][j] = up[i - 1][j] + 1;
            else
                up[i][j] = 1;
            if(up[i][j] > up[i][pos])
                pos = j;
        }
        mx[i] = pos;
    }
    int t = inf.readInt();
    for(int i = 1; i <= t; i++) {
        int l = inf.readInt();
        int r = inf.readInt();
        q.push_back({ l, r });
    }
    int ok1 = readAns(n, m, ans, up, q, mx);
    int ok2 = readAns(n, m, ouf, up, q, mx);
    if(ok1 == -1 && ok2 == -1)
        quitf(_ok, "%d numbers", n);
    else
        quitf(_wa, "%d query", ok1);
    return 0;
}
