#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main() {
    int n, m;
    cin >> n >> m;

    assert(m == 1 && n <= 100);

    vector <vector <int> > a(n, vector <int>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    }

    vector <int> ans(n);
    for (int i = 0; i < m; i++) {
        int cur = 0;
        for (int j = n - 1; j >= 0; j--) {
            if (j == n - 1 || a[j][i] <= a[j + 1][i])
                cur++;
            else
                cur = 1;

            ans[j] = max(ans[j], cur);
        }
    }

    int k;
    cin >> k;

    assert(k <= 100);

    for (int i = 0; i < k; i++) {
        int lb, rb;
        cin >> lb >> rb;

        if (lb + ans[lb - 1] > rb) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }

    return 0;
}
