#include "testlib.h"

const int32_t kMaxN = 1000;

int main(int argc, char* argv[])
{
    registerValidation(argc, argv);

    int32_t n = inf.readInt(1, kMaxN, "n");
    inf.readEoln();
    std::string sherlock_num = inf.readToken("[0-9]+");
    inf.readEoln();
    std::string moriarty_num = inf.readToken("[0-9]+");
    inf.readEoln();
    inf.readEof();

    ensuref(sherlock_num.size() == n, "wrong sherlock number length");
    ensuref(moriarty_num.size() == n, "wrong moriarty number length");

    return 0;
}
