#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);

int get(vector <int> sher, vector <int> mar, bool strict) {
    int ans = 0;
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j <= i - strict; j++) {
            int d = min(sher[j], mar[i]);
            ans += d;
            sher[j] -= d;
            mar[i] -= d;
        }
    }        

    return ans;
}

int main() {
    int n;
    string card[2];

    cin >> n;
    cin >> card[0] >> card[1];

    vector <int> cnt[2];
    cnt[0] = cnt[1] = vector <int>(10);

    for (int i = 0; i < 2; i++)
        for (int j = 0; j < n; j++)
            cnt[i][card[i][j] - '0']++;

    cout << n - get(cnt[0], cnt[1], false) << ' ';
    cout << get(cnt[0], cnt[1], true) << endl;


    return 0;
}
