#include "testlib.h"
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cstring>
#include <vector>
#include <stack>
#include <queue>
#include <deque>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>
#include <iomanip>
#include <ctime>
#include <cmath>
#include <bitset>

//#pragma comment(linker, "/STACK:256000000")

using namespace std;

typedef long long int ll;
typedef long double ld;

vector<string> arr;
vector<char> symb;

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);

	//int n = atoi(argv[1]);
	int len = atoi(argv[1]);
	int start_len = atoi(argv[2]);
	int min_dec = atoi(argv[3]);
	int max_dec = atoi(argv[4]);
	int alph = atoi(argv[5]);

    assert(start_len <= len);
    assert(alph <= 26);

    symb.resize(26);
    for (int i = 0; i < 26; ++i)
    {
        symb[i] = 'a' + i;
    }
    shuffle(symb.begin(), symb.end());
    sort(symb.begin(), symb.begin() + alph);

    string main_w = "";
    for (int i = 0; i < start_len; ++i)
    {
        main_w += symb[rnd.next(0, alph - 1)];
    }

    int n = 1;
    arr.push_back(main_w);
    len -= (int)main_w.size();
    while (len > 0)
    {
        int last_len = arr[n - 1].size();
        int new_len = min(len, max(1, last_len - rnd.next(min_dec, max_dec)));
        arr.push_back(arr[n - 1].substr(0, new_len));
        ++n;
        len -= new_len;
    }

    printf("%d\n", n);

    for (int i = 0; i < n; ++i)
    {
        printf("#%s\n", arr[i].c_str());
    }

	return 0;
}
