#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main() {
    int n;
    cin >> n;

    vector <pair <int, pair <int, int> > > towers;
    for (int i = 0; i < n; i++) {
        int a, b, h;
        cin >> a >> b >> h;

        towers.pb(mp(b, mp(a, h)));
    }

    sort(towers.rbegin(), towers.rend());

    vector <long long> ans(n);
    for (int i = 0; i < n; i++) {
        ans[i] = towers[i].sc.sc;
        for (int j = 0; j < i; j++) {
            if (towers[j].sc.fs < towers[i].fs)
                ans[i] = max(ans[i], ans[j] + towers[i].sc.sc);
        }    
    }
    
    long long rans = 0;
    for (int i = 0; i < n; i++)
        rans = max(rans, ans[i]);
        
    cout << rans << endl;

    return 0;
}
