#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cassert>
#include <ctime>
#include <cstring>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <list>
#include <deque>
#include <queue>
#include <sstream>
#include <iostream>
#include <algorithm>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const double pi = acos(-1.0);


int main() {
    int n;
    scanf("%d", &n);

    assert(n <= 15);

    vector <pair <int, pair <int, int> > > towers;
    for (int i = 0; i < n; i++) {
        int a, b, h;
        scanf("%d%d%d", &a, &b, &h);

        towers.pb(mp(b, mp(a, h)));
    }

    sort(towers.rbegin(), towers.rend());

    vector <int> ladder;

    long long rans = 0;
    vector <long long> ans(n);
    for (int i = 0; i < n; i++) {
        while (!ladder.empty() && towers[ladder.back()].sc.fs >= towers[i].fs)
            ladder.pop_back();
        if (!ladder.empty())
            ans[i] = ans[ladder.back()];
        ans[i] += towers[i].sc.sc;
        rans = max(rans, ans[i]);
        
        ladder.pb(i);
    }

    printf("%lld\n", rans);

    return 0;
}
