#include<iostream>
#include<vector>
#include<algorithm>
#define fi first
#define se second
#define pii pair<int, int>
using namespace std;

int tree[4000000];

int get(int x, int l, int r, int nl, int nr) {
    if ((l >= nr) || (r <= nl)) return 0;
    if ((l >= nl) && (r <= nr)) return tree[x];
    return max(get(x * 2, l, (l + r) / 2, nl, nr), 
               get(x * 2 + 1, (l + r) / 2, r, nl, nr));
}

void set(int x, int l, int r, int nx, int val) {
    if (l > nx) return;
    if (r <= nx) return;
    if (l + 1 == r) {
        tree[x] = max(tree[x], val);
        return;
    } 
    set(x * 2, l, (l + r) / 2, nx, val);
    set(x * 2 + 1, (l + r) / 2, r, nx, val);
    tree[x] = max(tree[x * 2], tree[x * 2 + 1]);
}
const int RN = 1000020;
int main(void) {
    ios::sync_with_stdio(0);
    int n;
    cin >> n;
    vector<pii> a(n);
    vector<int> d(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].se;
    }
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fi;
    }
    sort(a.rbegin(), a.rend());
    d[0] = 1;
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        if ((i < n - 1) && (a[i].fi == a[i + 1].fi)) continue;
        d[i] = 1;
        d[i] = max(1, 1 + get(1, 0, RN, 0, a[i].fi));
        set(1, 0, RN, a[i].se, d[i]);
        ans = max(ans, d[i]);
    }
    cout << ans << endl;
}
